Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 82)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 88)
@@ -14,42 +14,48 @@
   err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
   err (_("list_params is :\n"));
-  err (_(" * nb_read_unit                                                               (uint32_t           )\n"));
-  err (_(" * nb_functionnal_unit                                                        (uint32_t           )\n"));
-  err (_(" * nb_load_store_unit                                                         (uint32_t           )\n"));
-  err (_(" * nb_write_unit                                                              (uint32_t           )\n"));
-  err (_(" * nb_context                                                                 (uint32_t           )\n"));
-  err (_(" * nb_front_end                                                               (uint32_t           )\n"));
-  err (_(" * nb_ooo_engine                                                              (uint32_t           )\n"));
-  err (_(" * nb_packet                                                                  (uint32_t           )\n"));
-  err (_(" * size_general_data                                                          (uint32_t           )\n"));
-  err (_(" * size_special_data                                                          (uint32_t           )\n"));
-  err (_(" * size_read_queue                           [read_unit]                      (uint32_t           )\n"));
-  err (_(" * size_reservation_station                  [read_unit]                      (uint32_t           )\n"));
-  err (_(" * nb_inst_retire                            [read_unit]                      (uint32_t           )\n"));
-  err (_(" * size_store_queue                          [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * size_load_queue                           [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * size_speculative_access_queue             [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * nb_port_check                             [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * speculative_load                          [load_store_unit]                (Tspeculative_load_t)\n"));
-  err (_(" * nb_bypass_memory                          [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * size_write_queue                          [write_unit]                     (uint32_t           )\n"));
-  err (_(" * size_execute_queue                        [write_unit]                     (uint32_t           )\n"));
-  err (_(" * nb_bypass_write                           [write_unit]                     (uint32_t           )\n"));
-  err (_(" * nb_gpr_bank                                                                (uint32_t           )\n"));
-  err (_(" * nb_gpr_port_read_by_bank                                                   (uint32_t           )\n"));
-  err (_(" * nb_gpr_port_write_by_bank                                                  (uint32_t           )\n"));
-  err (_(" * nb_spr_bank                                                                (uint32_t           )\n"));
-  err (_(" * nb_spr_port_read_by_bank                                                   (uint32_t           )\n"));
-  err (_(" * nb_spr_port_write_by_bank                                                  (uint32_t           )\n"));
-  err (_(" * nb_general_register                       [nb_ooo_engine]                  (uint32_t           )\n"));
-  err (_(" * nb_special_register                       [nb_ooo_engine]                  (uint32_t           )\n"));
-  err (_(" * nb_inst_insert_rob                        [nb_ooo_engine]                  (uint32_t           )\n"));
-  err (_(" * nb_inst_retire_rob                        [nb_ooo_engine]                  (uint32_t           )\n"));
-  err (_(" * execution_unit_to_write_unit_priority                                      (Tpriority_t        )\n"));
-  err (_(" * execution_unit_to_write_unit_table_routing[nb_execute_unit][nb_write_unit] (bool               )\n"));
-  err (_(" * execution_unit_to_write_unit_table_thread [nb_write_unit][nb_thread]       (bool               )\n"));
-  err (_(" * read_unit_to_execution_unit_priority                                       (Tpriority_t        )\n"));
-  err (_(" * read_unit_to_execution_unit_table_routing [nb_read_unit][nb_execute_unit]  (bool               )\n"));
-  err (_(" * read_unit_to_execution_unit_table_thread  [nb_execute_unit][nb_thread]     (bool               )\n"));
+  err (_(" * nb_read_unit                                                                                     (uint32_t           )\n"));
+  err (_(" * nb_functionnal_unit                                                                              (uint32_t           )\n"));
+  err (_(" * nb_load_store_unit                                                                               (uint32_t           )\n"));
+  err (_(" * nb_write_unit                                                                                    (uint32_t           )\n"));
+  err (_(" * nb_context                                                                                       (uint32_t           )\n"));
+  err (_(" * nb_front_end                                                                                     (uint32_t           )\n"));
+  err (_(" * nb_ooo_engine                                                                                    (uint32_t           )\n"));
+  err (_(" * nb_packet                                                                                        (uint32_t           )\n"));
+  err (_(" * size_general_data                                                                                (uint32_t           )\n"));
+  err (_(" * size_special_data                                                                                (uint32_t           )\n"));
+  err (_(" * size_read_queue                           [nb_read_unit]                                         (uint32_t           )\n"));
+  err (_(" * size_reservation_station                  [nb_read_unit]                                         (uint32_t           )\n"));
+  err (_(" * nb_inst_retire                            [nb_read_unit]                                         (uint32_t           )\n"));
+  err (_(" * nb_inst_functionnal_unit                  [nb_functionnal_unit]                                  (uint32_t           )\n"));
+  err (_(" * size_store_queue                          [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * size_load_queue                           [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * size_speculative_access_queue             [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * nb_port_check                             [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * speculative_load                          [nb_load_store_unit]                                   (Tspeculative_load_t)\n"));
+  err (_(" * nb_bypass_memory                          [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * nb_cache_port                             [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * nb_inst_memory                            [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * size_write_queue                          [nb_write_unit]                                        (uint32_t           )\n"));
+  err (_(" * size_execute_queue                        [nb_write_unit]                                        (uint32_t           )\n"));
+  err (_(" * nb_bypass_write                           [nb_write_unit]                                        (uint32_t           )\n"));
+  err (_(" * nb_gpr_bank                                                                                      (uint32_t           )\n"));
+  err (_(" * nb_gpr_port_read_by_bank                                                                         (uint32_t           )\n"));
+  err (_(" * nb_gpr_port_write_by_bank                                                                        (uint32_t           )\n"));
+  err (_(" * nb_spr_bank                                                                                      (uint32_t           )\n"));
+  err (_(" * nb_spr_port_read_by_bank                                                                         (uint32_t           )\n"));
+  err (_(" * nb_spr_port_write_by_bank                                                                        (uint32_t           )\n"));
+  err (_(" * nb_general_register                       [nb_ooo_engine]                                        (uint32_t           )\n"));
+  err (_(" * nb_special_register                       [nb_ooo_engine]                                        (uint32_t           )\n"));
+  err (_(" * nb_inst_insert_rob                        [nb_ooo_engine]                                        (uint32_t           )\n"));
+  err (_(" * nb_inst_retire_rob                        [nb_ooo_engine]                                        (uint32_t           )\n"));
+  err (_(" * execution_unit_to_write_unit_priority                                                            (Tpriority_t        )\n"));
+  err (_(" * execution_unit_to_write_unit_table_routing[nb_execute_unit][nb_execute_unit_port][nb_write_unit] (bool               )\n"));
+  err (_(" * execution_unit_to_write_unit_table_thread [nb_write_unit][nb_thread]                             (bool               )\n"));
+  err (_(" * read_unit_to_execution_unit_priority                                                             (Tpriority_t        )\n"));
+  err (_(" * read_unit_to_execution_unit_table_routing [nb_read_unit][nb_execute_unit][nb_execute_unit_port]  (bool               )\n"));
+  err (_(" * read_unit_to_execution_unit_table_thread  [nb_execute_unit][nb_thread]                           (bool               )\n"));
+  err (_(" * is_load_store_unit                        [nb_execute_unit]                                      (bool               )\n"));
+  err (_(" * translate_num_execute_unit                [nb_execute_unit]                                      (uint32_t           )\n"));
+
 
   exit (1);
@@ -62,4 +68,9 @@
 #endif
 {
+  // Command
+  for (int32_t i=0; i<argc; ++i)
+    msg("%s ",argv[i]);
+  msg("\n");
+  
   if (argc < 2+NB_PARAMS)
     usage (argc, argv);
@@ -84,19 +95,17 @@
   int32_t nb_params = (2+NB_PARAMS+
 		       3*nb_read_unit+
-		       6*nb_load_store_unit+
+		       1*nb_functionnal_unit+
+		       8*nb_load_store_unit+
 		       3*nb_write_unit+
 		       4*nb_ooo_engine+
-		       nb_execute_unit*nb_write_unit+
+// 		       sum_execute_unit_port*nb_write_unit+
 		       nb_write_unit*nb_thread+
-		       nb_read_unit*nb_execute_unit+
-		       nb_execute_unit*nb_thread);
-  
-  
-  
-  if (argc != nb_params)
-    {
-      msg(_("Need %d parameters."),nb_params);
-      usage (argc, argv);
-    }
+// 		       nb_read_unit*sum_execute_unit_port+
+		       nb_execute_unit*nb_thread+
+                       2*nb_execute_unit);
+  
+  if (argc <= nb_params)
+    usage (argc, argv);
+  
   uint32_t            * size_read_queue          = new uint32_t [nb_read_unit];
   for (uint32_t i=0; i<nb_read_unit; i++)
@@ -111,4 +120,8 @@
     nb_inst_retire [i] = atoi(argv[x++]);
 
+  uint32_t            * nb_inst_functionnal_unit = new uint32_t [nb_functionnal_unit];
+  for (uint32_t i=0; i<nb_functionnal_unit; i++)
+    nb_inst_functionnal_unit [i] = atoi(argv[x++]);
+
   uint32_t          * size_store_queue              = new uint32_t [nb_load_store_unit];
   for (uint32_t i=0; i<nb_load_store_unit; i++)
@@ -134,4 +147,41 @@
   for (uint32_t i=0; i<nb_load_store_unit; i++)
     nb_bypass_memory              [i] = atoi(argv[x++]);
+
+  uint32_t          * nb_cache_port                 = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    nb_cache_port                 [i] = atoi(argv[x++]);
+
+  uint32_t          * nb_inst_memory                = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    nb_inst_memory                [i] = atoi(argv[x++]);
+
+
+  uint32_t sum_execute_unit_port = 0;
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    sum_execute_unit_port += nb_inst_memory[i];
+  for (uint32_t i=0; i<nb_functionnal_unit; i++)
+    sum_execute_unit_port += nb_inst_functionnal_unit[i];
+
+  nb_params = (2+NB_PARAMS+
+	       3*nb_read_unit+
+	       1*nb_functionnal_unit+
+	       8*nb_load_store_unit+
+	       3*nb_write_unit+
+	       4*nb_ooo_engine+
+	       sum_execute_unit_port*nb_write_unit+
+	       nb_write_unit*nb_thread+
+	       nb_read_unit*sum_execute_unit_port+
+	       nb_execute_unit*nb_thread+
+               2*nb_execute_unit);
+  
+  if (argc != nb_params)
+    {
+      msg("nb_functionnal_unit   : %d\n",nb_functionnal_unit);
+      msg("nb_load_store_unit    : %d\n",nb_load_store_unit );
+      msg("sum_execute_unit_port : %d.\n",sum_execute_unit_port);
+      msg(_("Have %d parameters.\n"),argc     );
+      msg(_("Need %d parameters.\n"),nb_params);
+      usage (argc, argv);
+    }
 
   uint32_t * size_write_queue   = new uint32_t [nb_write_unit];
@@ -172,11 +222,20 @@
   Tpriority_t execution_unit_to_write_unit_priority = fromString<Tpriority_t>(argv[x++]);
 
-  bool ** execution_unit_to_write_unit_table_routing = new bool * [nb_execute_unit];
+  bool *** execution_unit_to_write_unit_table_routing = new bool ** [nb_execute_unit];
   for (uint32_t i=0; i<nb_execute_unit; i++)
     {
-      execution_unit_to_write_unit_table_routing [i] = new bool [nb_write_unit];
-      for (uint32_t j=0; j<nb_write_unit; j++)
-	execution_unit_to_write_unit_table_routing [i][j] = atoi(argv[x++]);
-    }
+      uint32_t nb_execute_unit_port = (i<nb_load_store_unit)?nb_inst_memory[i]:nb_inst_functionnal_unit[i-nb_load_store_unit];
+
+      execution_unit_to_write_unit_table_routing [i] = new bool * [nb_execute_unit_port];
+      
+      for (uint32_t j=0; j<nb_execute_unit_port; j++)
+	{
+	  execution_unit_to_write_unit_table_routing [i][j] = new bool [nb_write_unit];
+	  
+	  for (uint32_t k=0; k<nb_write_unit; k++)
+	    execution_unit_to_write_unit_table_routing [i][j][k] = atoi(argv[x++]);
+	}
+    }
+
   bool ** execution_unit_to_write_unit_table_thread = new bool * [nb_write_unit];
   for (uint32_t i=0; i<nb_write_unit; i++)
@@ -188,11 +247,18 @@
   Tpriority_t read_unit_to_execution_unit_priority  = fromString<Tpriority_t>(argv[x++]);
 
-  bool ** read_unit_to_execution_unit_table_routing = new bool * [nb_read_unit];
+  bool *** read_unit_to_execution_unit_table_routing = new bool ** [nb_read_unit];
   for (uint32_t i=0; i<nb_read_unit; i++)
     {
-      read_unit_to_execution_unit_table_routing [i] = new bool [nb_execute_unit];
+      read_unit_to_execution_unit_table_routing [i] = new bool * [nb_execute_unit];
       for (uint32_t j=0; j<nb_execute_unit; j++)
-	read_unit_to_execution_unit_table_routing [i][j] = atoi(argv[x++]);
-    }
+	{
+	  uint32_t nb_execute_unit_port = (j<nb_load_store_unit)?nb_inst_memory[j]:nb_inst_functionnal_unit[j-nb_load_store_unit];
+	  read_unit_to_execution_unit_table_routing [i][j] = new bool [nb_execute_unit_port];
+
+	  for (uint32_t k=0; k<nb_execute_unit_port; k++)
+	    read_unit_to_execution_unit_table_routing [i][j][k] = atoi(argv[x++]);
+	}
+    }
+
   bool ** read_unit_to_execution_unit_table_thread = new bool * [nb_execute_unit];
   for (uint32_t i=0; i<nb_execute_unit; i++)
@@ -202,8 +268,16 @@
 	read_unit_to_execution_unit_table_thread [i][j] =  atoi(argv[x++]);
     }
-  execute_timing_t *** timing = new execute_timing_t ** [nb_execute_unit];
-  
+
+  bool * is_load_store_unit = new bool [nb_execute_unit];
+  for (uint32_t i=0; i<nb_execute_unit; i++)
+    is_load_store_unit [i] = fromString<bool>(argv[x++]);
+
+  uint32_t * translate_num_execute_unit = new uint32_t [nb_execute_unit];
+  for (uint32_t i=0; i<nb_execute_unit; i++)
+    translate_num_execute_unit [i] = fromString<uint32_t>(argv[x++]);
+
+  execute_timing_t *** timing = new execute_timing_t ** [nb_functionnal_unit];
   // alloc and reset timing array
-  for (uint32_t i=0; i< nb_execute_unit; i++)
+  for (uint32_t i=0; i< nb_functionnal_unit; i++)
     {
       timing [i] = new execute_timing_t * [MAX_TYPE];
@@ -218,14 +292,15 @@
     }
   
-  for (uint32_t i=0; i< nb_load_store_unit; i++)
-    for (uint32_t k=0; k< MAX_OPERATION; k++)
-      timing[i][TYPE_MEMORY][k]._delay = timing[i][TYPE_MEMORY][k]._latence = 1;
   for (uint32_t i=0; i< nb_functionnal_unit; i++)
     for (uint32_t j=0; j< MAX_TYPE; j++)
-      if (j != TYPE_MEMORY)
-	for (uint32_t k=0; k< MAX_OPERATION; k++)
-	  timing[i+nb_load_store_unit][j][k]._delay = timing[i+nb_load_store_unit][j][k]._latence = 1;
-
-  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (uint32_t) = &(morpheo::behavioural::custom::default_get_custom_information);
+      {
+	if ( (j != TYPE_MEMORY) and
+	     not ((i!=0) and ((j == TYPE_SPECIAL) or
+			      (j == TYPE_CUSTOM))))
+	  for (uint32_t k=0; k< MAX_OPERATION; k++)
+	    timing[i][j][k]._delay = timing[i][j][k]._latence = 1;
+      }
+
+  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void) = &(morpheo::behavioural::custom::default_get_custom_information);
 
   try 
@@ -247,5 +322,6 @@
 	 size_reservation_station                      ,
 	 nb_inst_retire                                ,
-	 
+
+	 nb_inst_functionnal_unit                      ,
 	 timing                                        ,
 	 get_custom_information                        ,
@@ -256,6 +332,8 @@
 	 nb_port_check                                 ,
 	 speculative_load                              ,
-	 
 	 nb_bypass_memory                              ,
+	 nb_cache_port                                 ,
+	 nb_inst_memory                                ,
+
 	 size_write_queue                              ,
 	 size_execute_queue                            ,
@@ -279,7 +357,10 @@
 	 read_unit_to_execution_unit_priority          ,
 	 read_unit_to_execution_unit_table_routing     ,
-	 read_unit_to_execution_unit_table_thread      );
-      
-      msg(_("%s"),param->print(1).c_str());
+	 read_unit_to_execution_unit_table_thread      ,
+
+         is_load_store_unit                            , //[nb_execute_unit]
+         translate_num_execute_unit                    , //[nb_execute_unit]
+         true // is_toplevel
+         );
       
       test (name,param);
@@ -287,10 +368,10 @@
   catch (morpheo::ErrorMorpheo & error)
     {
-      msg (_("<%s> : %s.\n"),name.c_str(), error.what ());
+      msg (_("%s\n"),error.what ());
       exit (EXIT_FAILURE);
     }
   catch (...)
     {
-      err (_("<%s> : This test must generate a error.\n"),name.c_str());
+      err (_("This test must generate a error.\n"));
       exit (EXIT_FAILURE);
     }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp	(revision 82)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp	(revision 88)
@@ -7,5 +7,5 @@
  */
 
-#define NB_ITERATION  1
+#define NB_ITERATION  128
 #define CYCLE_MAX     (128*NB_ITERATION)
 
@@ -21,6 +21,16 @@
 
 #ifdef STATISTICS
-  morpheo::behavioural::Parameters_Statistics * _parameters_statistics = new morpheo::behavioural::Parameters_Statistics (5,50);
+  morpheo::behavioural::Parameters_Statistics * _parameters_statistics = new morpheo::behavioural::Parameters_Statistics (5,CYCLE_MAX);
 #endif
+
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
 
   Execute_loop * _Execute_loop = new Execute_loop 
@@ -30,5 +40,5 @@
 #endif
      _param,
-     USE_ALL);
+     _usage);
   
 #ifdef SYSTEMC
@@ -75,33 +85,34 @@
   ALLOC1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_NO_SEQUENCE         ,"out_EXECUTE_LOOP_OUT_NO_SEQUENCE         ",Tcontrol_t        ,_param->_nb_write_unit);
   ALLOC1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_ADDRESS             ,"out_EXECUTE_LOOP_OUT_ADDRESS             ",Tgeneral_data_t   ,_param->_nb_write_unit);
-  ALLOC1_SC_SIGNAL(out_DCACHE_REQ_VAL                       ,"out_DCACHE_REQ_VAL                       ",Tcontrol_t        ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL( in_DCACHE_REQ_ACK                       ," in_DCACHE_REQ_ACK                       ",Tcontrol_t        ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL(out_DCACHE_REQ_CONTEXT_ID                ,"out_DCACHE_REQ_CONTEXT_ID                ",Tcontext_t        ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL(out_DCACHE_REQ_PACKET_ID                 ,"out_DCACHE_REQ_PACKET_ID                 ",Tpacket_t         ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL(out_DCACHE_REQ_ADDRESS                   ,"out_DCACHE_REQ_ADDRESS                   ",Tdcache_address_t ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL(out_DCACHE_REQ_TYPE                      ,"out_DCACHE_REQ_TYPE                      ",Tdcache_type_t    ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL(out_DCACHE_REQ_WDATA                     ,"out_DCACHE_REQ_WDATA                     ",Tdcache_data_t    ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL( in_DCACHE_RSP_VAL                       ," in_DCACHE_RSP_VAL                       ",Tcontrol_t        ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL(out_DCACHE_RSP_ACK                       ,"out_DCACHE_RSP_ACK                       ",Tcontrol_t        ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL( in_DCACHE_RSP_CONTEXT_ID                ," in_DCACHE_RSP_CONTEXT_ID                ",Tcontext_t        ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL( in_DCACHE_RSP_PACKET_ID                 ," in_DCACHE_RSP_PACKET_ID                 ",Tpacket_t         ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL( in_DCACHE_RSP_RDATA                     ," in_DCACHE_RSP_RDATA                     ",Tdcache_data_t    ,_param->_nb_load_store_unit);
-  ALLOC1_SC_SIGNAL( in_DCACHE_RSP_ERROR                     ," in_DCACHE_RSP_ERROR                     ",Tdcache_error_t   ,_param->_nb_load_store_unit); 
-  ALLOC2_SC_SIGNAL( in_INSERT_ROB_VAL                       ," in_INSERT_ROB_VAL                       ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL(out_INSERT_ROB_ACK                       ,"out_INSERT_ROB_ACK                       ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_INSERT_ROB_RD_USE                    ," in_INSERT_ROB_RD_USE                    ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_INSERT_ROB_RD_NUM_REG                ," in_INSERT_ROB_RD_NUM_REG                ",Tgeneral_address_t,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_INSERT_ROB_RE_USE                    ," in_INSERT_ROB_RE_USE                    ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_INSERT_ROB_RE_NUM_REG                ," in_INSERT_ROB_RE_NUM_REG                ",Tspecial_address_t,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_VAL                       ," in_RETIRE_ROB_VAL                       ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL(out_RETIRE_ROB_ACK                       ,"out_RETIRE_ROB_ACK                       ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RD_OLD_USE                ," in_RETIRE_ROB_RD_OLD_USE                ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]); 
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RD_OLD_NUM_REG            ," in_RETIRE_ROB_RD_OLD_NUM_REG            ",Tgeneral_address_t,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RD_NEW_USE                ," in_RETIRE_ROB_RD_NEW_USE                ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RD_NEW_NUM_REG            ," in_RETIRE_ROB_RD_NEW_NUM_REG            ",Tgeneral_address_t,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RE_OLD_USE                ," in_RETIRE_ROB_RE_OLD_USE                ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]); 
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RE_OLD_NUM_REG            ," in_RETIRE_ROB_RE_OLD_NUM_REG            ",Tspecial_address_t,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RE_NEW_USE                ," in_RETIRE_ROB_RE_NEW_USE                ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RE_NEW_NUM_REG            ," in_RETIRE_ROB_RE_NEW_NUM_REG            ",Tspecial_address_t,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
+  ALLOC1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_DATA                ,"out_EXECUTE_LOOP_OUT_DATA                ",Tgeneral_data_t   ,_param->_nb_write_unit);
+  ALLOC2_SC_SIGNAL(out_DCACHE_REQ_VAL                       ,"out_DCACHE_REQ_VAL                       ",Tcontrol_t        ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL( in_DCACHE_REQ_ACK                       ," in_DCACHE_REQ_ACK                       ",Tcontrol_t        ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL(out_DCACHE_REQ_CONTEXT_ID                ,"out_DCACHE_REQ_CONTEXT_ID                ",Tcontext_t        ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL(out_DCACHE_REQ_PACKET_ID                 ,"out_DCACHE_REQ_PACKET_ID                 ",Tpacket_t         ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL(out_DCACHE_REQ_ADDRESS                   ,"out_DCACHE_REQ_ADDRESS                   ",Tdcache_address_t ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL(out_DCACHE_REQ_TYPE                      ,"out_DCACHE_REQ_TYPE                      ",Tdcache_type_t    ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL(out_DCACHE_REQ_WDATA                     ,"out_DCACHE_REQ_WDATA                     ",Tdcache_data_t    ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL( in_DCACHE_RSP_VAL                       ," in_DCACHE_RSP_VAL                       ",Tcontrol_t        ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL(out_DCACHE_RSP_ACK                       ,"out_DCACHE_RSP_ACK                       ",Tcontrol_t        ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL( in_DCACHE_RSP_CONTEXT_ID                ," in_DCACHE_RSP_CONTEXT_ID                ",Tcontext_t        ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL( in_DCACHE_RSP_PACKET_ID                 ," in_DCACHE_RSP_PACKET_ID                 ",Tpacket_t         ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL( in_DCACHE_RSP_RDATA                     ," in_DCACHE_RSP_RDATA                     ",Tdcache_data_t    ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  ALLOC2_SC_SIGNAL( in_DCACHE_RSP_ERROR                     ," in_DCACHE_RSP_ERROR                     ",Tdcache_error_t   ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]); 
+  ALLOC2_SC_SIGNAL( in_INSERT_ROB_VAL                       ," in_INSERT_ROB_VAL                       ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  ALLOC2_SC_SIGNAL(out_INSERT_ROB_ACK                       ,"out_INSERT_ROB_ACK                       ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  ALLOC2_SC_SIGNAL( in_INSERT_ROB_RD_USE                    ," in_INSERT_ROB_RD_USE                    ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  ALLOC2_SC_SIGNAL( in_INSERT_ROB_RD_NUM_REG                ," in_INSERT_ROB_RD_NUM_REG                ",Tgeneral_address_t,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  ALLOC2_SC_SIGNAL( in_INSERT_ROB_RE_USE                    ," in_INSERT_ROB_RE_USE                    ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  ALLOC2_SC_SIGNAL( in_INSERT_ROB_RE_NUM_REG                ," in_INSERT_ROB_RE_NUM_REG                ",Tspecial_address_t,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_VAL                       ," in_RETIRE_ROB_VAL                       ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   ALLOC2_SC_SIGNAL(out_RETIRE_ROB_ACK                       ,"out_RETIRE_ROB_ACK                       ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RD_OLD_USE                ," in_RETIRE_ROB_RD_OLD_USE                ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]); 
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RD_OLD_NUM_REG            ," in_RETIRE_ROB_RD_OLD_NUM_REG            ",Tgeneral_address_t,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RD_NEW_USE                ," in_RETIRE_ROB_RD_NEW_USE                ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RD_NEW_NUM_REG            ," in_RETIRE_ROB_RD_NEW_NUM_REG            ",Tgeneral_address_t,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RE_OLD_USE                ," in_RETIRE_ROB_RE_OLD_USE                ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]); 
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RE_OLD_NUM_REG            ," in_RETIRE_ROB_RE_OLD_NUM_REG            ",Tspecial_address_t,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RE_NEW_USE                ," in_RETIRE_ROB_RE_NEW_USE                ",Tcontrol_t        ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   ALLOC2_SC_SIGNAL( in_RETIRE_ROB_RE_NEW_NUM_REG            ," in_RETIRE_ROB_RE_NEW_NUM_REG            ",Tspecial_address_t,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
   
   /********************************************************
@@ -122,5 +133,5 @@
   if (_param->_have_port_ooo_engine_id)
   INSTANCE1_SC_SIGNAL(_Execute_loop, in_EXECUTE_LOOP_IN_OOO_ENGINE_ID        ,_param->_nb_read_unit);
-  if (_param->_have_port_packet_id)
+  if (_param->_have_port_rob_ptr  )
   INSTANCE1_SC_SIGNAL(_Execute_loop, in_EXECUTE_LOOP_IN_PACKET_ID            ,_param->_nb_read_unit);
   INSTANCE1_SC_SIGNAL(_Execute_loop, in_EXECUTE_LOOP_IN_OPERATION            ,_param->_nb_read_unit);
@@ -149,5 +160,5 @@
   if (_param->_have_port_ooo_engine_id)
   INSTANCE1_SC_SIGNAL(_Execute_loop,out_EXECUTE_LOOP_OUT_OOO_ENGINE_ID       ,_param->_nb_write_unit);
-  if (_param->_have_port_packet_id)
+  if (_param->_have_port_rob_ptr  )
   INSTANCE1_SC_SIGNAL(_Execute_loop,out_EXECUTE_LOOP_OUT_PACKET_ID           ,_param->_nb_write_unit);
 //INSTANCE1_SC_SIGNAL(_Execute_loop,out_EXECUTE_LOOP_OUT_OPERATION           ,_param->_nb_write_unit);
@@ -157,35 +168,36 @@
   INSTANCE1_SC_SIGNAL(_Execute_loop,out_EXECUTE_LOOP_OUT_NO_SEQUENCE         ,_param->_nb_write_unit);
   INSTANCE1_SC_SIGNAL(_Execute_loop,out_EXECUTE_LOOP_OUT_ADDRESS             ,_param->_nb_write_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_VAL                       ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop, in_DCACHE_REQ_ACK                       ,_param->_nb_load_store_unit);
+  INSTANCE1_SC_SIGNAL(_Execute_loop,out_EXECUTE_LOOP_OUT_DATA                ,_param->_nb_write_unit);
+  INSTANCE2_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_VAL                       ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_DCACHE_REQ_ACK                       ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
   if (_param->_have_port_dcache_context_id)
-  INSTANCE1_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_CONTEXT_ID                ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_PACKET_ID                 ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_ADDRESS                   ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_TYPE                      ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_WDATA                     ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_VAL                       ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop,out_DCACHE_RSP_ACK                       ,_param->_nb_load_store_unit);
+  INSTANCE2_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_CONTEXT_ID                ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_PACKET_ID                 ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_ADDRESS                   ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_TYPE                      ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop,out_DCACHE_REQ_WDATA                     ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_VAL                       ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop,out_DCACHE_RSP_ACK                       ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
   if (_param->_have_port_dcache_context_id)
-  INSTANCE1_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_CONTEXT_ID                ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_PACKET_ID                 ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_RDATA                     ,_param->_nb_load_store_unit);
-  INSTANCE1_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_ERROR                     ,_param->_nb_load_store_unit); 
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_VAL                       ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop,out_INSERT_ROB_ACK                       ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_RD_USE                    ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_RD_NUM_REG                ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_RE_USE                    ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_RE_NUM_REG                ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_VAL                       ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop,out_RETIRE_ROB_ACK                       ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RD_OLD_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]); 
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RD_OLD_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RD_NEW_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RD_NEW_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RE_OLD_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]); 
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RE_OLD_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RE_NEW_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
-  INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RE_NEW_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[alloc_signal_it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_CONTEXT_ID                ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_PACKET_ID                 ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_RDATA                     ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_DCACHE_RSP_ERROR                     ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]); 
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_VAL                       ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop,out_INSERT_ROB_ACK                       ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_RD_USE                    ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_RD_NUM_REG                ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_RE_USE                    ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  INSTANCE2_SC_SIGNAL(_Execute_loop, in_INSERT_ROB_RE_NUM_REG                ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_VAL                       ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   INSTANCE2_SC_SIGNAL(_Execute_loop,out_RETIRE_ROB_ACK                       ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RD_OLD_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]); 
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RD_OLD_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RD_NEW_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RD_NEW_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RE_OLD_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]); 
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RE_OLD_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RE_NEW_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   INSTANCE2_SC_SIGNAL(_Execute_loop, in_RETIRE_ROB_RE_NEW_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
 
   msg(_("<%s> : Start Simulation ............\n"),name.c_str());
@@ -233,67 +245,68 @@
   delete in_NRESET;
 
-  delete []  in_EXECUTE_LOOP_IN_VAL                  ;
-  delete [] out_EXECUTE_LOOP_IN_ACK                  ;
-  delete []  in_EXECUTE_LOOP_IN_CONTEXT_ID           ;
-  delete []  in_EXECUTE_LOOP_IN_FRONT_END_ID         ;
-  delete []  in_EXECUTE_LOOP_IN_OOO_ENGINE_ID        ;
-  delete []  in_EXECUTE_LOOP_IN_PACKET_ID            ;
-  delete []  in_EXECUTE_LOOP_IN_OPERATION            ;
-  delete []  in_EXECUTE_LOOP_IN_TYPE                 ;
-  delete []  in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE;
-  delete []  in_EXECUTE_LOOP_IN_LOAD_QUEUE_PTR_WRITE ;
-  delete []  in_EXECUTE_LOOP_IN_HAS_IMMEDIAT         ;
-  delete []  in_EXECUTE_LOOP_IN_IMMEDIAT             ;
-  delete []  in_EXECUTE_LOOP_IN_READ_RA              ;
-  delete []  in_EXECUTE_LOOP_IN_NUM_REG_RA           ;
-  delete []  in_EXECUTE_LOOP_IN_READ_RB              ;
-  delete []  in_EXECUTE_LOOP_IN_NUM_REG_RB           ;
-  delete []  in_EXECUTE_LOOP_IN_READ_RC              ;
-  delete []  in_EXECUTE_LOOP_IN_NUM_REG_RC           ;
-  delete []  in_EXECUTE_LOOP_IN_WRITE_RD             ;
-  delete []  in_EXECUTE_LOOP_IN_NUM_REG_RD           ;
-  delete []  in_EXECUTE_LOOP_IN_WRITE_RE             ;
-  delete []  in_EXECUTE_LOOP_IN_NUM_REG_RE           ;
-  delete [] out_EXECUTE_LOOP_OUT_VAL                 ;
-  delete []  in_EXECUTE_LOOP_OUT_ACK                 ;
-  delete [] out_EXECUTE_LOOP_OUT_CONTEXT_ID          ;
-  delete [] out_EXECUTE_LOOP_OUT_FRONT_END_ID        ;
-  delete [] out_EXECUTE_LOOP_OUT_OOO_ENGINE_ID       ;
-  delete [] out_EXECUTE_LOOP_OUT_PACKET_ID           ;
-//delete [] out_EXECUTE_LOOP_OUT_OPERATION           ;
-//delete [] out_EXECUTE_LOOP_OUT_TYPE                ;
-  delete [] out_EXECUTE_LOOP_OUT_FLAGS               ;
-  delete [] out_EXECUTE_LOOP_OUT_EXCEPTION           ;
-  delete [] out_EXECUTE_LOOP_OUT_NO_SEQUENCE         ;
-  delete [] out_EXECUTE_LOOP_OUT_ADDRESS             ;
-  delete [] out_DCACHE_REQ_VAL                       ;
-  delete []  in_DCACHE_REQ_ACK                       ;
-  delete [] out_DCACHE_REQ_CONTEXT_ID                ;
-  delete [] out_DCACHE_REQ_PACKET_ID                 ;
-  delete [] out_DCACHE_REQ_ADDRESS                   ;
-  delete [] out_DCACHE_REQ_TYPE                      ;
-  delete [] out_DCACHE_REQ_WDATA                     ;
-  delete []  in_DCACHE_RSP_VAL                       ;
-  delete [] out_DCACHE_RSP_ACK                       ;
-  delete []  in_DCACHE_RSP_CONTEXT_ID                ;
-  delete []  in_DCACHE_RSP_PACKET_ID                 ;
-  delete []  in_DCACHE_RSP_RDATA                     ;
-  delete []  in_DCACHE_RSP_ERROR                     ;
-  delete []  in_INSERT_ROB_VAL                       ;
-  delete [] out_INSERT_ROB_ACK                       ;
-  delete []  in_INSERT_ROB_RD_USE                    ;
-  delete []  in_INSERT_ROB_RD_NUM_REG                ;
-  delete []  in_INSERT_ROB_RE_USE                    ;
-  delete []  in_INSERT_ROB_RE_NUM_REG                ;
-  delete []  in_RETIRE_ROB_VAL                       ;
-  delete [] out_RETIRE_ROB_ACK                       ;
-  delete []  in_RETIRE_ROB_RD_OLD_USE                ; 
-  delete []  in_RETIRE_ROB_RD_OLD_NUM_REG            ;
-  delete []  in_RETIRE_ROB_RD_NEW_USE                ;
-  delete []  in_RETIRE_ROB_RD_NEW_NUM_REG            ;
-  delete []  in_RETIRE_ROB_RE_OLD_USE                ; 
-  delete []  in_RETIRE_ROB_RE_OLD_NUM_REG            ;
-  delete []  in_RETIRE_ROB_RE_NEW_USE                ;
-  delete []  in_RETIRE_ROB_RE_NEW_NUM_REG            ;
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_VAL                  ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_IN_ACK                  ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_CONTEXT_ID           ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_FRONT_END_ID         ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_OOO_ENGINE_ID        ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_PACKET_ID            ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_OPERATION            ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_TYPE                 ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_LOAD_QUEUE_PTR_WRITE ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_HAS_IMMEDIAT         ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_IMMEDIAT             ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_READ_RA              ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_NUM_REG_RA           ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_READ_RB              ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_NUM_REG_RB           ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_READ_RC              ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_NUM_REG_RC           ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_WRITE_RD             ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_NUM_REG_RD           ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_WRITE_RE             ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_NUM_REG_RE           ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_VAL                 ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_OUT_ACK                 ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_CONTEXT_ID          ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_FRONT_END_ID        ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_OOO_ENGINE_ID       ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_PACKET_ID           ,_param->_nb_write_unit);
+//DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_OPERATION           ,_param->_nb_write_unit);
+//DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_TYPE                ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_FLAGS               ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_EXCEPTION           ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_NO_SEQUENCE         ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_ADDRESS             ,_param->_nb_write_unit);
+  DELETE1_SC_SIGNAL(out_EXECUTE_LOOP_OUT_DATA                ,_param->_nb_write_unit);
+  DELETE2_SC_SIGNAL(out_DCACHE_REQ_VAL                       ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL( in_DCACHE_REQ_ACK                       ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL(out_DCACHE_REQ_CONTEXT_ID                ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL(out_DCACHE_REQ_PACKET_ID                 ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL(out_DCACHE_REQ_ADDRESS                   ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL(out_DCACHE_REQ_TYPE                      ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL(out_DCACHE_REQ_WDATA                     ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL( in_DCACHE_RSP_VAL                       ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL(out_DCACHE_RSP_ACK                       ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL( in_DCACHE_RSP_CONTEXT_ID                ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL( in_DCACHE_RSP_PACKET_ID                 ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL( in_DCACHE_RSP_RDATA                     ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+  DELETE2_SC_SIGNAL( in_DCACHE_RSP_ERROR                     ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]); 
+  DELETE2_SC_SIGNAL( in_INSERT_ROB_VAL                       ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  DELETE2_SC_SIGNAL(out_INSERT_ROB_ACK                       ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  DELETE2_SC_SIGNAL( in_INSERT_ROB_RD_USE                    ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  DELETE2_SC_SIGNAL( in_INSERT_ROB_RD_NUM_REG                ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  DELETE2_SC_SIGNAL( in_INSERT_ROB_RE_USE                    ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+  DELETE2_SC_SIGNAL( in_INSERT_ROB_RE_NUM_REG                ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_VAL                       ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   DELETE2_SC_SIGNAL(out_RETIRE_ROB_ACK                       ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_RD_OLD_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]); 
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_RD_OLD_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_RD_NEW_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_RD_NEW_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_RE_OLD_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]); 
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_RE_OLD_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_RE_NEW_USE                ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
+//   DELETE2_SC_SIGNAL( in_RETIRE_ROB_RE_NEW_NUM_REG            ,_param->_nb_ooo_engine,_param->_nb_inst_retire_rob[it1]);
 
 #endif
